Qore::StringInputStream Class Reference

This class implements the InputStream interface for reading bytes from a String variable. More...

Inheritance diagram for Qore::StringInputStream:
[legend]

## Public Member Functions

| constructor (string src)
| Creates the StringInputStream based on the String given. More...
string | getEncoding ()
| Returns the character encoding for the StringInputStream. More...
int | peek ()
| Peeks the next byte available from the input stream; returns -1 if no more data available. More...
*binary | read (int limit)
| Reads bytes (up to a specified limit) from the input stream; returns NOTHING if there are no more bytes in the stream. More...
Public Member Functions inherited from Qore::InputStream
| constructor ()
| Constructor. More...

## Detailed Description

This class implements the InputStream interface for reading bytes from a String variable.

Since
  Qore 0.8.13

Example: StringInputStream basic usage
  string src = "abc";
  StringInputStream sis(src);
  *binary b;
  while (b = sis.read(2)) {
  printf("read %s\n", make_hex_string(b));
  }
  read 6162
  read 63

Note
  stream classes are not designed to be accessed from multiple threads; they have been implemented without locking for fast and efficient use when used from a single thread. For methods that would be unsafe to use in another thread, any use of such methods in threads other than the thread where the constructor was called will cause a `STREAM-THREAD-ERROR` to be thrown.

See also
  StreamReader for a class that can be used to read various kinds of data from an InputStream

## Member Function Documentation

## constructor()

Qore::StringInputStream::constructor | ( | string | src | ) |

Creates the StringInputStream based on the String given.

Parameters

  src | the String to read bytes from

## getEncoding()

string Qore::StringInputStream::getEncoding | ( |  | ) |

Returns the character encoding for the StringInputStream.

Code Flags:
  CONSTANT

Example:
  string src = "xyz";
  StringInputStream is(src);
  string encoding = is.getEncoding();

Returns
  the character encoding for the StringInputStream

## peek()

int Qore::StringInputStream::peek | ( |  | ) |

virtual

Peeks the next byte available from the input stream; returns -1 if no more data available.

Returns
  the next byte available from the input stream or -1 if no more data is available

Example:
  string src = "xyz";
  StringInputStream is(src);
  printf("peek: %d\n", is.peek());
  *binary b = is.read(3);
  printf("peek: %d\n", is.peek());
  peek 120
  peek -1

Exceptions

  STREAM-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Implements Qore::InputStream.

## read()

*binary Qore::StringInputStream::read | ( | int | limit | ) |

virtual

Reads bytes (up to a specified limit) from the input stream; returns NOTHING if there are no more bytes in the stream.

Parameters

  limit | the maximum number of bytes to read

Returns
  the read bytes (the length is between 1 and `limit` inclusive) or NOTHING if no more bytes are available

Example:
  string src = "xyz";
  StringInputStream is(src);
  *binary b;
  while (b = is.read(2)) {
  printf("read %s\n", make_hex_string(b));
  }
  read 7879
  read 7a

Exceptions

  INPUT-STREAM-ERROR | limit is not positive
  STREAM-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Implements Qore::InputStream.